Index: squid/src/store_dir.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_dir.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/store_dir.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/store_dir.c	3 May 2000 19:22:27 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_dir.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: store_dir.c,v 1.1.1.3.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 47    Store Directory Routines
  * AUTHOR: Duane Wessels
@@ -35,15 +35,10 @@
 
 #include "squid.h"
 
+static int storeDirValidSwapDirSize(int, size_t);
 static void storeDirLRUWalkInitHead(SwapDir * sd);
 static void *storeDirLRUWalkNext(SwapDir * sd);
 
-const char *SwapDirType[] =
-{
-    "ufs",
-    "!ERROR!"
-};
-
 void
 storeDirInit(void)
 {
@@ -79,6 +74,33 @@
 }
 
 /*
+ * Determine whether the given directory can handle this object
+ * size
+ *
+ * Note: if the object size is -1, then the only swapdirs that
+ * will return true here are ones that have max_obj_size = -1,
+ * ie any-sized-object swapdirs. This is a good thing.
+ */
+static int
+storeDirValidSwapDirSize(int swapdir, size_t objsize)
+{
+    /*
+     * If the swapdir's max_obj_size is -1, then it definitely can
+     */
+    if (Config.cacheSwap.swapDirs[swapdir].max_objsize == -1)
+        return 1;
+    /*
+     * Else, make sure that the max object size is larger than objsize
+     */
+    if (Config.cacheSwap.swapDirs[swapdir].max_objsize > objsize)
+        return 1;
+    else
+        return 0;
+}
+
+
+#if UNUSED /* Squid-2..4.DEVEL3 code */
+/*
  * This new selection scheme simply does round-robin on all SwapDirs.
  * A SwapDir is skipped if it is over the max_size (100%) limit.  If
  * all SwapDir's are above the limit, then the first dirn that we
@@ -141,154 +163,72 @@
 }
 #endif
 
-#if OLD
+#endif /* Squid-2.4.DEVEL3 code */
+
 /*
- * This is Stew Forster's selection algorithm.
- * Spread load across least 3/4 of the store directories
+ * Spread load across all of the store directories
+ *
+ * Note: We should modify this later on to prefer sticking objects
+ * in the *tightest fit* swapdir to conserve space, along with the
+ * actual swapdir usage. But for now, this hack will do while  
+ * testing, so you should order your swapdirs in the config file
+ * from smallest maxobjsize to unlimited (-1) maxobjsize.
+ *
+ * We also have to choose nleast == nconf since we need to consider
+ * ALL swapdirs, regardless of state. Again, this is a hack while
+ * we sort out the real usefulness of this algorithm.
  */
-static int
-storeDirSelectSwapDir(void)
+int
+storeDirSelectSwapDir(const StoreEntry *e)
 {
-    double least_used = 1.0;
-    double high = (double) Config.Swap.highWaterMark / 100.0;
-    double u;
-    int dirn;
-    int i, j;
+    size_t objsize;
+    size_t least_size;
+    size_t least_objsize;
+    int least_load = 1000;
+    int load;
+    int dirn = -1;
+    int i;
     SwapDir *SD;
-    static int nleast = 0;
-    static int nconf = 0;
-    static int *dirq = NULL;
-    static double *diru = NULL;
-    /*
-     * Handle simplest case of a single swap directory immediately
-     */
-    if (Config.cacheSwap.n_configured == 1)
-	return 0;
-    /*
-     * Initialise dirq on the first call or on change of number of dirs
-     */
-    if (nconf != Config.cacheSwap.n_configured) {
-	nconf = Config.cacheSwap.n_configured;
-	nleast = (nconf * 3) / 4;
-	safe_free(dirq);
-	dirq = (int *) xmalloc(sizeof(int) * nleast);
-	safe_free(diru);
-	diru = (double *) xmalloc(sizeof(double) * nconf);
-	for (j = 0; j < nleast; j++)
-	    dirq[j] = -1;
-    }
-    /*
-     * Scan for a non-negative dirn in the dirq array and return that one
-     */
-    dirn = -1;
-    for (j = 0; j < nleast; j++) {
-	dirn = dirq[j];
-	if (dirn < 0)
-	    continue;
-	dirq[j] = -1;
-	break;
-    }
-    /*
-     * If we found a valid dirn return it
-     */
-    if (dirn >= 0)
-	return dirn;
-    /*
-     * Now for the real guts of the algorithm - building the dirq array
-     */
-    for (i = 0; i < nconf; i++) {
-	diru[i] = 1.1;
-	SD = &Config.cacheSwap.swapDirs[i];
+
+    /* Calculate the object size */
+    objsize = objectLen(e);
+    if (objsize != -1)
+	objsize += e->mem_obj->swap_hdr_sz;
+    /* Initial defaults */
+    least_size = Config.cacheSwap.swapDirs[0].cur_size;
+    least_objsize = Config.cacheSwap.swapDirs[0].max_objsize;
+    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+        SD = &Config.cacheSwap.swapDirs[i];
 	SD->flags.selected = 0;
-	if (SD->flags.read_only)
-	    continue;
-	u = (double) SD->cur_size / SD->max_size;
-	if (u > high)
-	    continue;
-	diru[i] = u;
-    }
-    for (j = 0; j < nleast; j++) {
-	dirq[j] = -1;
-	least_used = 1.0;
-	dirn = -1;
-	for (i = 0; i < nconf; i++) {
-	    if (diru[i] < least_used) {
-		least_used = diru[i];
-		dirn = i;
-	    }
-	}
-	if (dirn < 0)
-	    break;
-	dirq[j] = dirn;
-	diru[dirn] = 1.1;
-	/* set selected flag for debugging/cachemgr only */
-	Config.cacheSwap.swapDirs[dirn].flags.selected = 1;
+        if (SD->flags.read_only)
+            continue;
+        /* Valid for object size check */
+        if (!storeDirValidSwapDirSize(i, objsize))
+            continue;
+        load = SD->checkobj(SD, e);
+        if (load < 0)
+	    continue;
+        if (SD->cur_size > SD->max_size)
+            continue;
+        if (load > least_load)
+            continue;
+        if ((least_objsize > 0) && (objsize > least_objsize))
+            continue;
+        /* Only use leastsize if the load is equal */
+        if ((load == least_load) && (SD->cur_size > least_size))
+            continue;
+        least_load = load;
+        least_size = SD->cur_size;
+        dirn = i;
     }
-    /*
-     * Setup default return of 0 if no least found
-     */
-    if (dirq[0] < 0)
-	dirq[0] = 0;
-    dirn = dirq[0];
-    dirq[0] = -1;
-    return dirn;
-}
-#endif
 
-int
-storeDirValidFileno(int fn, int flag)
-{
-    int dirn = fn >> SWAP_DIR_SHIFT;
-    int filn = fn & SWAP_FILE_MASK;
-    if (dirn > Config.cacheSwap.n_configured)
-	return 0;
-    if (dirn < 0)
-	return 0;
-    if (filn < 0)
-	return 0;
-    /*
-     * If flag is set it means out-of-range file number should
-     * be considered invalid.
-     */
-    if (flag)
-	if (filn > Config.cacheSwap.swapDirs[dirn].map->max_n_files)
-	    return 0;
-    return 1;
-}
+    if (dirn >= 0)
+	Config.cacheSwap.swapDirs[dirn].flags.selected = 1;
 
-int
-storeDirMapBitTest(int fn)
-{
-    int dirn = fn >> SWAP_DIR_SHIFT;
-    int filn = fn & SWAP_FILE_MASK;
-    return file_map_bit_test(Config.cacheSwap.swapDirs[dirn].map, filn);
+    return dirn;
 }
 
-void
-storeDirMapBitSet(int fn)
-{
-    int dirn = fn >> SWAP_DIR_SHIFT;
-    int filn = fn & SWAP_FILE_MASK;
-    file_map_bit_set(Config.cacheSwap.swapDirs[dirn].map, filn);
-}
 
-void
-storeDirMapBitReset(int fn)
-{
-    int dirn = fn >> SWAP_DIR_SHIFT;
-    int filn = fn & SWAP_FILE_MASK;
-    file_map_bit_reset(Config.cacheSwap.swapDirs[dirn].map, filn);
-}
-
-int
-storeDirMapAllocate(void)
-{
-    int dirn = storeDirSelectSwapDir();
-    SwapDir *SD = &Config.cacheSwap.swapDirs[dirn];
-    int filn = file_map_allocate(SD->map, SD->suggest);
-    SD->suggest = filn + 1;
-    return (dirn << SWAP_DIR_SHIFT) | (filn & SWAP_FILE_MASK);
-}
 
 char *
 storeSwapDir(int dirn)
@@ -297,18 +237,6 @@
     return Config.cacheSwap.swapDirs[dirn].path;
 }
 
-int
-storeDirNumber(int swap_file_number)
-{
-    return swap_file_number >> SWAP_DIR_SHIFT;
-}
-
-int
-storeDirProperFileno(int dirn, int fn)
-{
-    return (dirn << SWAP_DIR_SHIFT) | (fn & SWAP_FILE_MASK);
-}
-
 /*
  * An entry written to the swap log MUST have the following
  * properties.
@@ -316,36 +244,34 @@
  *       a public ADD, change the key, then log a private
  *       DEL.  So we need to log a DEL before we change a
  *       key from public to private.
- *   2.  It MUST have a valid (> -1) swap_file_number.
+ *   2.  It MUST have a valid (> -1) swap_filen.
  */
 void
 storeDirSwapLog(const StoreEntry * e, int op)
 {
-    int dirn = e->swap_file_number >> SWAP_DIR_SHIFT;
     SwapDir *sd;
-    assert(dirn < Config.cacheSwap.n_configured);
     assert(!EBIT_TEST(e->flags, KEY_PRIVATE));
-    assert(e->swap_file_number >= 0);
+    assert(e->swap_filen >= 0);
     /*
      * icons and such; don't write them to the swap log
      */
     if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
 	return;
     assert(op > SWAP_LOG_NOP && op < SWAP_LOG_MAX);
-    debug(20, 3) ("storeDirSwapLog: %s %s %08X\n",
+    debug(20, 3) ("storeDirSwapLog: %s %s %d %08X\n",
 	swap_log_op_str[op],
 	storeKeyText(e->key),
-	e->swap_file_number);
-    sd = &Config.cacheSwap.swapDirs[dirn];
+        e->swap_dirn,
+	e->swap_filen);
+    sd = &Config.cacheSwap.swapDirs[e->swap_dirn];
     sd->log.write(sd, e, op);
 }
 
 void
-storeDirUpdateSwapSize(int fn, size_t size, int sign)
+storeDirUpdateSwapSize(SwapDir *SD, size_t size, int sign)
 {
-    int dirn = (fn >> SWAP_DIR_SHIFT) % Config.cacheSwap.n_configured;
     int k = ((size + 1023) >> 10) * sign;
-    Config.cacheSwap.swapDirs[dirn].cur_size += k;
+    SD->cur_size += k;
     store_swap_size += k;
     if (sign > 0)
 	n_disk_objects++;
@@ -356,6 +282,9 @@
 void
 storeDirStats(StoreEntry * sentry)
 {
+    int i;
+    SwapDir *SD;
+
     storeAppendPrintf(sentry, "Store Directory Statistics:\n");
     storeAppendPrintf(sentry, "Store Entries          : %d\n",
 	memInUse(MEM_STOREENTRY));
@@ -366,17 +295,15 @@
     storeAppendPrintf(sentry, "Current Capacity       : %d%% used, %d%% free\n",
 	percent((int) store_swap_size, (int) Config.Swap.maxSize),
 	percent((int) (Config.Swap.maxSize - store_swap_size), (int) Config.Swap.maxSize));
-    storeUfsDirStats(sentry);	/* XXX */
-}
 
-int
-storeDirMapBitsInUse(void)
-{
-    int i;
-    int n = 0;
-    for (i = 0; i < Config.cacheSwap.n_configured; i++)
-	n += Config.cacheSwap.swapDirs[i].map->n_files_in_map;
-    return n;
+    /* Now go through each swapdir, calling its statfs routine */
+    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+        storeAppendPrintf(sentry, "\n");
+        SD = &(Config.cacheSwap.swapDirs[i]);
+        storeAppendPrintf(sentry, "Store Directory #%d (%s): %s\n", i, SD->type,
+          storeSwapDir(i));
+        SD->statfs(SD, sentry);
+    }
 }
 
 void
@@ -388,17 +315,14 @@
     for (i = 0; i < Config.cacheSwap.n_configured; i++) {
 	SD = &Config.cacheSwap.swapDirs[i];;
 	Config.Swap.maxSize += SD->max_size;
-	if (NULL == SD->map)
-	    SD->map = file_map_create();
 	SD->low_size = (int) (((float) SD->max_size *
 		(float) Config.Swap.lowWaterMark) / 100.0);
     }
 }
 
 void
-storeDirDiskFull(int fn)
+storeDirDiskFull(sdirno dirn)
 {
-    int dirn = fn >> SWAP_DIR_SHIFT;
     SwapDir *SD = &Config.cacheSwap.swapDirs[dirn];
     assert(0 <= dirn && dirn < Config.cacheSwap.n_configured);
     SD->max_size = SD->cur_size;
@@ -432,6 +356,10 @@
  *  storeDirWriteCleanLogs
  * 
  *  Writes a "clean" swap log file from in-memory metadata.
+ *  This is a rewrite of the original function to troll each
+ *  StoreDir and write the logs, and flush at the end of
+ *  the run. Thanks goes to Eric Stern, since this solution
+ *  came out of his COSS code.
  */
 #define CLEAN_BUF_SZ 16384
 int
@@ -445,8 +373,6 @@
     int dirn;
 #if HEAP_REPLACEMENT
     int node;
-#else
-    int j;
 #endif
     if (store_dirs_rebuilding) {
 	debug(20, 1) ("Not currently OK to rewrite swap log.\n");
@@ -462,58 +388,23 @@
 	    debug(20, 1) ("log.clean.open() failed for dir #%d\n", sd->index);
 	    continue;
 	}
-#if !HEAP_REPLACEMENT
-	storeDirLRUWalkInitHead(sd);
-#endif
-    }
-#if HEAP_REPLACEMENT
-    if (NULL == store_heap)
-	return 0;
-    for (node = 0; node < heap_nodes(store_heap); node++) {
-	e = (StoreEntry *) heap_peep(store_heap, node);
-	if (e->swap_file_number < 0)
-	    continue;
-	if (e->swap_status != SWAPOUT_DONE)
-	    continue;
-	if (e->swap_file_sz <= 0)
-	    continue;
-	if (EBIT_TEST(e->flags, RELEASE_REQUEST))
-	    continue;
-	if (EBIT_TEST(e->flags, KEY_PRIVATE))
-	    continue;
-	if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
-	    continue;
-	dirn = storeDirNumber(e->swap_file_number);
-	sd = &Config.cacheSwap.swapDirs[dirn];
-	if (NULL == sd->log.clean.write)
-	    continue;
-	sd->log.clean.write(e, sd);
-	if ((++n & 0xFFFF) == 0) {
-	    getCurrentTime();
-	    debug(20, 1) ("  %7d entries written so far.\n", n);
-	}
-    }
-    /* flush */
-    for (dirn = 0; dirn < N; dirn++) {
-	sd = &Config.cacheSwap.swapDirs[dirn];
 	if (NULL == sd->log.clean.write)
 	    continue;
-	sd->log.clean.write(NULL, sd);
-    }
+#if HEAP_REPLACEMENT
+        if (NULL == sd->repl.heap.heap)
+            continue;
+#endif
+#if HEAP_REPLACEMENT
+        for (node = 0; node < heap_nodes(sd->repl.heap.heap); node++)
 #else
-    do {
-	j = 0;
-	for (dirn = 0; dirn < Config.cacheSwap.n_configured; dirn++) {
-	    sd = &Config.cacheSwap.swapDirs[dirn];
-	    if (NULL == sd->log.clean.write)
-		continue;
-	    e = storeDirLRUWalkNext(sd);
-	    if (NULL == e) {
-		sd->log.clean.write(NULL, sd);
-		continue;
-	    }
-	    j++;
-	    if (e->swap_file_number < 0)
+	storeDirLRUWalkInitHead(sd);
+        while ((e = storeDirLRUWalkNext(sd)) != NULL)
+#endif
+        {
+#if HEAP_REPLACEMENT
+	    e = (StoreEntry *) heap_peep(sd->repl.heap.heap, node);
+#endif
+	    if (e->swap_filen < 0)
 		continue;
 	    if (e->swap_status != SWAPOUT_DONE)
 		continue;
@@ -531,8 +422,9 @@
 		debug(20, 1) ("  %7d entries written so far.\n", n);
 	    }
 	}
-    } while (j > 0);
-#endif
+        /* Flush */
+        sd->log.clean.write(NULL, sd);
+    }
     if (reopen)
 	storeDirOpenSwapLogs();
     getCurrentTime();
@@ -544,14 +436,47 @@
 }
 #undef CLEAN_BUF_SZ
 
+/*
+ * sync all avaliable fs'es ..
+ */
+void
+storeDirSync(void)
+{
+    int i;
+    SwapDir *SD;
+
+    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+        SD = &Config.cacheSwap.swapDirs[i];
+        if (SD->sync != NULL)
+            SD->sync(SD);
+    }
+}
+
+/*
+ * handle callbacks all avaliable fs'es ..
+ */
+void
+storeDirCallback(void)
+{
+    int i;
+    SwapDir *SD;
+
+    for (i = 0; i < Config.cacheSwap.n_configured; i++) {
+        SD = &Config.cacheSwap.swapDirs[i];
+        if (SD->callback != NULL)
+            SD->callback(SD);
+    }
+}
+
+#if 0 /* from Squid-2.4.DEVEL3 */
 void
 storeDirLRUDelete(StoreEntry * e)
 {
     SwapDir *sd;
-    if (e->swap_file_number < 0)
+    if (e->swap_filen < 0)
 	return;
-    sd = &Config.cacheSwap.swapDirs[e->swap_file_number >> SWAP_DIR_SHIFT];
-    dlinkDelete(&e->lru, &sd->lru_list);
+    sd = &Config.cacheSwap.swapDirs[e->swap_dirn];
+    dlinkDelete(&e->lru, &sd->repl.lru.list);
 }
 
 void
@@ -560,23 +485,24 @@
     SwapDir *sd;
     if (e->swap_file_number < 0)
 	return;
-    sd = &Config.cacheSwap.swapDirs[e->swap_file_number >> SWAP_DIR_SHIFT];
-    dlinkAdd(e, &e->lru, &sd->lru_list);
+    sd = &Config.cacheSwap.swapDirs[e->swap_dirn];
+    dlinkAdd(e, &e->lru, &sd->repl.lru.list);
 }
+#endif /* from Squid-2.4.DEVEL3 */
 
 static void
 storeDirLRUWalkInitHead(SwapDir * sd)
 {
-    sd->lru_walker = sd->lru_list.head;
+    sd->repl.lru.walker = sd->repl.lru.list.head;
 }
 
 static void *
 storeDirLRUWalkNext(SwapDir * sd)
 {
     void *p;
-    if (NULL == sd->lru_walker)
+    if (NULL == sd->repl.lru.walker)
 	return NULL;
-    p = sd->lru_walker->data;
-    sd->lru_walker = sd->lru_walker->next;
+    p = sd->repl.lru.walker->data;
+    sd->repl.lru.walker = sd->repl.lru.walker->next;
     return p;
 }
Index: squid/src/store_heap_replacement.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/Attic/store_heap_replacement.c,v
retrieving revision 1.1.1.1.8.1
retrieving revision 1.1.1.1.8.2
diff -u -r1.1.1.1.8.1 -r1.1.1.1.8.2
--- squid/src/store_heap_replacement.c	16 Apr 2000 23:59:17 -0000	1.1.1.1.8.1
+++ squid/src/store_heap_replacement.c	3 May 2000 19:22:27 -0000	1.1.1.1.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_heap_replacement.c,v 1.1.1.1.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: store_heap_replacement.c,v 1.1.1.1.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Heap-based replacement
  * AUTHOR: John Dilley
@@ -41,6 +41,10 @@
  *  http://www.hpl.hp.com/techreports/1999/HPL-1999-69.html
  */
 
+#include "squid.h"
+
+#if HEAP_REPLACEMENT
+
 /*
  * Key generation function to implement the LFU-DA policy (Least
  * Frequently Used with Dynamic Aging).  Similar to classical LFU
@@ -54,7 +58,7 @@
  * (e->lastref): for objects that have the same reference count
  * the most recent object wins (gets a higher key value).
  */
-static heap_key
+heap_key
 HeapKeyGen_StoreEntry_LFUDA(void *entry, double age)
 {
     StoreEntry *e = entry;
@@ -81,7 +85,7 @@
  * (e->lastref): for objects that have the same reference count
  * the most recent object wins (gets a higher key value).
  */
-static heap_key
+heap_key
 HeapKeyGen_StoreEntry_GDSF(void *entry, double age)
 {
     StoreEntry *e = entry;
@@ -97,9 +101,11 @@
  * Don't use it unless you are trying to compare performance among
  * heap-based replacement policies...
  */
-static heap_key
+heap_key
 HeapKeyGen_StoreEntry_LRU(void *entry, double age)
 {
     StoreEntry *e = entry;
     return (heap_key) e->lastref;
 }
+
+#endif
Index: squid/src/store_io.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_io.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.8.1
diff -u -r1.1.1.1 -r1.1.1.1.8.1
--- squid/src/store_io.c	26 Jan 2000 03:25:01 -0000	1.1.1.1
+++ squid/src/store_io.c	3 May 2000 19:22:27 -0000	1.1.1.1.8.1
@@ -1,44 +1,83 @@
 #include "squid.h"
 
 
+/*
+ * submit a request to create a cache object for writing.
+ * The StoreEntry structure is sent as a hint to the filesystem
+ * to what will be stored in this object, to allow the filesystem
+ * to select different polices depending on object size or type.
+ */
+storeIOState *
+storeCreate(StoreEntry *e, STIOCB *file_callback, STIOCB *close_callback, void *callback_data)
+{
+    size_t objsize;
+    sdirno dirn;
+    SwapDir *SD;
+
+    /* This is just done for logging purposes */
+    objsize = objectLen(e);
+    if (objsize != -1)
+        objsize += e->mem_obj->swap_hdr_sz;
+
+    /*
+     * Pick the swapdir
+     * We assume that the header has been packed by now ..
+     */
+    dirn = storeDirSelectSwapDir(e);
+    if (dirn == -1) {
+        debug(20, 2) ("storeCreate: no valid swapdirs for this object\n");
+        return NULL;
+    }
+    debug (20, 2) ("storeCreate: Selected dir '%d' for obj size '%d'\n", dirn, objsize);
+    SD = &Config.cacheSwap.swapDirs[dirn];
+
+    /* Now that we have a fs to use, call its storeCreate function */
+    return(SD->obj.create(SD, e, file_callback, close_callback, callback_data));
+
+    /* Done */
+}
+
 
+/*
+ * storeOpen() is purely for reading ..
+ */
 storeIOState *
-storeOpen(sfileno f, mode_t mode, STIOCB * callback, void *callback_data)
+storeOpen(StoreEntry *e, STFNCB * file_callback, STIOCB * callback,
+  void *callback_data)
 {
-    SwapDir *SD = &Config.cacheSwap.swapDirs[f >> SWAP_DIR_SHIFT];
-    assert(mode == O_RDONLY || mode == O_WRONLY);
-    return SD->obj.open(f, mode, callback, callback_data);
+    SwapDir *SD = &Config.cacheSwap.swapDirs[e->swap_dirn];
+    return SD->obj.open(SD, e, file_callback, callback, callback_data);
 }
 
 void
 storeClose(storeIOState * sio)
 {
-    SwapDir *SD = &Config.cacheSwap.swapDirs[sio->swap_file_number >> SWAP_DIR_SHIFT];
+    SwapDir *SD = &Config.cacheSwap.swapDirs[sio->swap_dirn];
     if (sio->flags.closing)
 	return;
     sio->flags.closing = 1;
-    SD->obj.close(sio);
+    SD->obj.close(SD, sio);
 }
 
 void
 storeRead(storeIOState * sio, char *buf, size_t size, off_t offset, STRCB * callback, void *callback_data)
 {
-    SwapDir *SD = &Config.cacheSwap.swapDirs[sio->swap_file_number >> SWAP_DIR_SHIFT];
-    SD->obj.read(sio, buf, size, offset, callback, callback_data);
+    SwapDir *SD = &Config.cacheSwap.swapDirs[sio->swap_dirn];
+    SD->obj.read(SD, sio, buf, size, offset, callback, callback_data);
 }
 
 void
 storeWrite(storeIOState * sio, char *buf, size_t size, off_t offset, FREE * free_func)
 {
-    SwapDir *SD = &Config.cacheSwap.swapDirs[sio->swap_file_number >> SWAP_DIR_SHIFT];
-    SD->obj.write(sio, buf, size, offset, free_func);
+    SwapDir *SD = &Config.cacheSwap.swapDirs[sio->swap_dirn];
+    SD->obj.write(SD, sio, buf, size, offset, free_func);
 }
 
 void
-storeUnlink(sfileno f)
+storeUnlink(StoreEntry *e)
 {
-    SwapDir *SD = &Config.cacheSwap.swapDirs[f >> SWAP_DIR_SHIFT];
-    SD->obj.unlink(f);
+    SwapDir *SD = INDEXSD(e->swap_dirn);
+    SD->obj.unlink(SD, e);
 }
 
 off_t
Index: squid/src/store_log.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_log.c,v
retrieving revision 1.1.1.2.8.1
retrieving revision 1.1.1.2.8.2
diff -u -r1.1.1.2.8.1 -r1.1.1.2.8.2
--- squid/src/store_log.c	16 Apr 2000 23:59:17 -0000	1.1.1.2.8.1
+++ squid/src/store_log.c	3 May 2000 19:22:27 -0000	1.1.1.2.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_log.c,v 1.1.1.2.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: store_log.c,v 1.1.1.2.8.2 2000/05/03 19:22:27 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Logging Functions
  * AUTHOR: Duane Wessels
@@ -62,11 +62,17 @@
 	mem->log_url = xstrdup(mem->url);
     }
     reply = mem->reply;
-    logfilePrintf(storelog, "%9d.%03d %-7s %08X %4d %9d %9d %9d %s %d/%d %s %s\n",
+    /*
+     * XXX Ok, where should we print the dir number here?
+     * Because if we print it before the swap file number, it'll break
+     * the existing log format.
+     */
+    logfilePrintf(storelog, "%9d.%03d %-7s %02d %08X %4d %9d %9d %9d %s %d/%d %s %s\n",
 	(int) current_time.tv_sec,
 	(int) current_time.tv_usec / 1000,
 	storeLogTags[tag],
-	e->swap_file_number,
+        e->swap_dirn,
+	e->swap_filen,
 	reply->sline.status,
 	(int) reply->date,
 	(int) reply->last_modified,
Index: squid/src/store_rebuild.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_rebuild.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/store_rebuild.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/store_rebuild.c	3 May 2000 19:22:28 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_rebuild.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: store_rebuild.c,v 1.1.1.3.8.2 2000/05/03 19:22:28 hno Exp $
  *
  * DEBUG: section 20    Store Rebuild Routines
  * AUTHOR: Duane Wessels
@@ -40,36 +40,10 @@
 static void storeCleanup(void *);
 
 static int
-storeCleanupDoubleCheck(const StoreEntry * e)
+storeCleanupDoubleCheck(StoreEntry * e)
 {
-    /* XXX too UFS specific */
-    struct stat sb;
-    int dirn = e->swap_file_number >> SWAP_DIR_SHIFT;
-    if (Config.cacheSwap.swapDirs[dirn].type == SWAPDIR_UFS)
-	(void) 0;
-    if (Config.cacheSwap.swapDirs[dirn].type == SWAPDIR_ASYNCUFS)
-	(void) 0;
-    else
-	return 0;
-    if (stat(storeUfsFullPath(e->swap_file_number, NULL), &sb) < 0) {
-	debug(20, 0) ("storeCleanup: MISSING SWAP FILE\n");
-	debug(20, 0) ("storeCleanup: FILENO %08X\n", e->swap_file_number);
-	debug(20, 0) ("storeCleanup: PATH %s\n",
-	    storeUfsFullPath(e->swap_file_number, NULL));
-	storeEntryDump(e, 0);
-	return -1;
-    }
-    if (e->swap_file_sz != sb.st_size) {
-	debug(20, 0) ("storeCleanup: SIZE MISMATCH\n");
-	debug(20, 0) ("storeCleanup: FILENO %08X\n", e->swap_file_number);
-	debug(20, 0) ("storeCleanup: PATH %s\n",
-	    storeUfsFullPath(e->swap_file_number, NULL));
-	debug(20, 0) ("storeCleanup: ENTRY SIZE: %d, FILE SIZE: %d\n",
-	    e->swap_file_sz, (int) sb.st_size);
-	storeEntryDump(e, 0);
-	return -1;
-    }
-    return 0;
+    SwapDir *SD = &Config.cacheSwap.swapDirs[e->swap_dirn];
+    return (SD->dblcheck(SD, e));
 }
 
 static void
@@ -106,7 +80,7 @@
 	     * Calling storeRelease() has no effect because we're
 	     * still in 'store_rebuilding' state
 	     */
-	    if (e->swap_file_number < 0)
+	    if (e->swap_filen < 0)
 		continue;
 	    if (opt_store_doublecheck)
 		if (storeCleanupDoubleCheck(e))
@@ -116,7 +90,7 @@
 	     * Only set the file bit if we know its a valid entry
 	     * otherwise, set it in the validation procedure
 	     */
-	    storeDirUpdateSwapSize(e->swap_file_number, e->swap_file_sz, 1);
+	    storeDirUpdateSwapSize(&Config.cacheSwap.swapDirs[e->swap_dirn], e->swap_file_sz, 1);
 	    if ((++validnum & 0x3FFFF) == 0)
 		debug(20, 1) ("  %7d Entries Validated so far.\n", validnum);
 	}
Index: squid/src/store_swapin.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/store_swapin.c,v
retrieving revision 1.1.1.3.8.1
retrieving revision 1.1.1.3.8.2
diff -u -r1.1.1.3.8.1 -r1.1.1.3.8.2
--- squid/src/store_swapin.c	16 Apr 2000 23:59:17 -0000	1.1.1.3.8.1
+++ squid/src/store_swapin.c	3 May 2000 19:22:28 -0000	1.1.1.3.8.2
@@ -1,6 +1,6 @@
 
 /*
- * $Id: store_swapin.c,v 1.1.1.3.8.1 2000/04/16 23:59:17 hno Exp $
+ * $Id: store_swapin.c,v 1.1.1.3.8.2 2000/05/03 19:22:28 hno Exp $
  *
  * DEBUG: section 20    Storage Manager Swapin Functions
  * AUTHOR: Duane Wessels
@@ -36,6 +36,7 @@
 #include "squid.h"
 
 static STIOCB storeSwapInFileClosed;
+static STFNCB storeSwapInFileNotify;
 
 void
 storeSwapInStart(store_client * sc)
@@ -46,24 +47,22 @@
 	/* We're still reloading and haven't validated this entry yet */
 	return;
     }
-    debug(20, 3) ("storeSwapInStart: called for %08X %s \n",
-	e->swap_file_number, storeKeyText(e->key));
+    debug(20, 3) ("storeSwapInStart: called for %d %08X %s \n",
+	e->swap_dirn, e->swap_filen, storeKeyText(e->key));
     if (e->swap_status != SWAPOUT_WRITING && e->swap_status != SWAPOUT_DONE) {
 	debug(20, 1) ("storeSwapInStart: bad swap_status (%s)\n",
 	    swapStatusStr[e->swap_status]);
 	return;
     }
-    if (e->swap_file_number < 0) {
-	debug(20, 1) ("storeSwapInStart: swap_file_number < 0\n");
+    if (e->swap_filen < 0) {
+	debug(20, 1) ("storeSwapInStart: swap_filen < 0\n");
 	return;
     }
     assert(e->mem_obj != NULL);
     debug(20, 3) ("storeSwapInStart: Opening fileno %08X\n",
-	e->swap_file_number);
-    sc->swapin_sio = storeOpen(e->swap_file_number,
-	O_RDONLY,
-	storeSwapInFileClosed,
-	sc);
+	e->swap_filen);
+    sc->swapin_sio = storeOpen(e, storeSwapInFileNotify, storeSwapInFileClosed,
+      sc);
     cbdataLock(sc->swapin_sio);
 }
 
@@ -82,3 +81,15 @@
 	callback(sc->callback_data, sc->copy_buf, errflag);
     }
 }
+
+static void
+storeSwapInFileNotify(void *data, int errflag, storeIOState * sio)
+{
+  store_client *sc = data;
+  StoreEntry *e = sc->entry;
+ 
+  debug(1, 3) ("storeSwapInFileNotify: changing %d/%d to %d/%d\n", e->swap_filen, e->swap_dirn, sio->swap_filen, sio->swap_dirn);
+
+  e->swap_filen = sio->swap_filen;
+  e->swap_dirn = sio->swap_dirn;
+}
